Overview of as, the GNU Assembler

Contents|Index|Next
Overview of as, the GNU assembler

The following documentation serves as a overview to the user guide for the GNU assembler, as.

- Structure of this documentation
- as, the GNU assembler
- Object file formats
- Command line
- Input files
- Output (object) file
- Error and warning messages

The following summarizes briefly how to invoke as. For details, see Command-line options.

    as [ -a[cdhlns][=file] ] [ -D ] [ --defsym sym=value ]
       [ -f ] [ --gstabs ][ --help ] [ -I dir ][-J][-K ][-L ]
       [ --keep-locals ] [ -o objfile ] [ -R ] [ --statistics ]
       [ -v ] [ -version ]    [ --version ] [ -W ] [ -w ] [ -x ] [ -Z ]
       [ -mbig-endian | -mlittle-endian ]
       [ -m[arm]1 | -m[arm]2 | -m[arm]250 | -m[arm]3 | -m[arm]6
                                             | -m[arm]7[t][d]m[i]] ]
       [ -m[arm]v2 | -m[arm]v2a | -m[arm]v3 | -m[arm]v3m | -m[arm]v4
                                                      | -m[arm]v4t ]
       [ -mthumb | -mall ]
       [ -mfpa10 | -mfpa11 | -mfpe-old | -mno-fpu
       [ -EB | -EL ]
       [ -mapcs-32 | -mapcs-26]
       [ -O ]
       [ -O | -n | -N ]
       [ -Av6 | -Av7 | -Av8 | -Asparclite | -Av8plus | -Av8plus -Av9
                                                     | -Av9a ]
       [ -xarch=v8plus | -xarch=v8plusa ] [ -bump ]
       [ -ACA | -ACA_A | -ACB | -ACC | -AKA | -AKB | -AKC | -AMC ]
       [ -b ] [ -no-relax ]
       [ -l ] [ -m68000 | -m68010 | -m68020 |...]
       [ -nocpp ] [ -EL ] [ -EB ] [ -G num ] [ -mcpu=CPU ]
       [ -mips1 ] [ -mips2 ] [ -mips3 ] [ -m4650 ] [ -no-m4650 ]
       [ --trap ] [ --break ]
       [ --emulation=name ]
       [ -- | files...]

Unlike older assemblers, `as` is designed to assemble a source program in one pass of the source file. This has a subtle impact on the .org directive.

-a[cdhlmns]

Turn on listings, in any of a variety of ways:

- -ac
Omit false conditionals
- -ad
Omit debugging directives
- -ah
Include high-level source
- -al
Include assembly
- -am
Include macro expansions
- -an
Omit forms processing
- -as
Include symbols
- =file
Set the name of the listing file

You may combine these options; for example, use -aln for assembly listing without forms processing. The =file option, if used, must be the last one. By itself, -a defaults to -ahls.

-D

Ignored. This option is accepted for script compatibility with calls to other assemblers.

--defsym sym= value

Define the symbol sym to be value before assembling the input file. value must be an integer constant. As in C, a leading 0x indicates a hexadecimal value, and a leading 0 indicates an octal value.

-f

“Fast”—skip whitespace and comment preprocessing (assume source is compiler output).

--gstabs

Generate stabs debugging information for each assembler line. This may help debugging assembler code, if the debugger can handle it.

--help

Print a summary of the command line options and exit.

-I dir

Add directory, dir, to the search list for .include directives.

-J

Don’t warn about signed overflow.

-K

Issue warnings when difference tables altered for long displacements.

-L

Keep (in the symbol table) local symbols, starting with L.

--keep-locals

Keep (in the symbol table) local symbols. On traditional a.out systems these start with L, but different systems have different local label prefixes.

-o objfile

Name the object-file output from as objfile.

-R

Fold the data section into the text section.

--statistics

Print the maximum space (in bytes) and total time (in seconds) used by assembly.

--strip-local-absolute

Remove local absolute symbols from the outgoing symbol table.

-v
-version

Print the as version.

--version

Print the as version and exit.

-W

Suppress warning messages.

-w

Ignored.

-x

Ignored.

-Z

Generate an object file even after errors.

-- | files...

Standard input, or source files (files ...) to assemble.

The following options are available when `as` is configured for an ARC processor.

> -mbig-endian

> > Generate big endian format output.

> -mlittle-endian

> > Generate little endian format output.

The following options are available when `as` is configured for the ARM processor family.

> -m[arm]1 | -m[arm]2 | -m[arm]250 | -m[arm]3 | -m[arm]6 |
> -m[arm]7[t][[d]m] | -m[arm]v2 | -m[arm]v2a | -m[arm]v3 |
> -m[arm]v3m | -m[arm]v4 | -m[arm]v4t

> > Specify which variant of the ARM architecture is the target.

> -mthumb | -mall

> > Enable or disable Thumb only instruction decoding.

> -mfpa10 | -mfpa11 | -mfpe-old | -mno-fpu

> > Select which floating point architcture is the target.

> -mapcs-32 | -mapcs-26

> > Select which procedure calling convention is in use.

> -EB | -EL

> > Select either big-endian (-EB) or little-endian (-EL) output.

The following options are available when `as` is configured for a D10V processor.

> -O

> > Optimize output by parallelizing instructions.

The following options are available when `as` is configured for a D30V processor.

> -O

> > Optimize output by parallelizing instructions.

> -n

> > Warn when nops are generated.

> -N

> > Warn when a nop after a 32-bit multiply instruction is generated.

The following options are available when `as` is configured for the Intel 80960 processor.

> -ACA | -ACA_A | -ACB | -ACC | -AKA | -AKB | -AKC | -AMC

> > Specify which variant of the 960 architecture is the target.

> -b

> > Add code to collect statistics about branches taken.

> -no-relax

> > Do not alter compare-and-branch instructions for long displacements; error if necessary.

The following options are available when as is configured for the Mitsubishi M32R series of processors.

> --m32rx

> > Specify which processor in the M32R family is the target. The default is normally the M32R, but this option changes it to the M32R/X.

> --warn-explicit-parallel-conflicts | --Wp

> > Produce warning messages when questionable parallel constructs are encountered.

> --no-warn-explicit-parallel-conflicts | --Wnp

> > Do not produce warning messages when questionable parallel constructs are encountered.

The following options are available when `as` is configured for the Motorola 68000 series.

> -l

> > Shorten references to undefined symbols, to one word instead of two.

> -m68000 | -m68008 | -m68010 | -m68020 | -m68030 | -m68040 | -m68060
> -m68302 | -m68331 | -m68332 | -m68333 | -m68340 | -mcpu32 | -m5200

> > Specify what processor in the 68000 family is the target.
> > The default is normally the 68020, but this can be changed at configuration time.

> -m68881 | -m68882 | -mno-68881 | -mno-68882

> > The target machine does (or does not using the opposite input, with -mno-68881 being -m68881) have a floating-point coprocessor. The default is to assume a coprocessor for 68020, 68030, and the CPU32. Although the basic 68000 is not compatible with the 68881, a combination of the two can be specified, since it’s possible to do emulation of the coprocessor instructions with the main processor.

> -m68851 | -mno-68851

> > The target machine does (or does not) have a memory-management unit coprocessor. The default is to assume an MMU for 68020 and up.

The following options are available when `as` is configured for the SPARC architecture.

> -Av6 | -Av7 | -Av8 | -Asparclet | -Asparclite
> -Av8plus | -Av8plusa | -Av9 | -Av9a

> > Explicitly select a variant of the SPARC architecture.
> > -Av8plus and -Av8plusa select a 32 bit environment.
> > -Av9 and -Av9a select a 64 bit environment.
> > -Av8plusa and -Av9a enable the SPARC V9 instruction set with UltraSPARC extensions.

> -xarch=v8plus | -xarch=v8plusa

> > For compatibility with the Solaris v9 assembler. These options are equivalent to -Av8plus and -Av8plusa, respectively.

> -bump

> > Warn when the assembler switches to another architecture.

The following options are available when `as` is configured for a MIPS processor.

> -G num

> > This option sets the largest size of an object that can be referenced implicitly with the gp register. It is only accepted for targets that use ECOFF format, such as a DECstation running Ultrix. The default value is 8.

> -EB

> > Generate “big endian” format output.

> -EL

> > Generate “little endian” format output.

> -mips1
> -mips2
> -mips3

> > Generate code for a particular MIPS Instruction Set Architecture level. -mips1 corresponds to the r2000 and r3000 processors, -mips2 to the r6000 processor, and -mips3 to the r4000 processor.

> -m4650
> -no-m4650

> > Generate code for the MIPS r4650 chip. This tells the assembler to accept the mad and madu instruction, and to not schedule nop instructions around accesses to the HI and LO registers. -no-m4650 turns off this option.

> -mcpu=CPU

> > Generate code for a particular MIPS processor. This has little effect on the assembler, but it is passed by GCC.

> --emulation=name

> > This option causes as to emulate as configured for some other target, in all respects, including output format (choosing between ELF and ECOFF only), handling of pseudo-opcodes which may generate debugging information or store symbol table information, and default endianness. The available configuration names are mipsecoff, mipself, mipslecoff, mipsbecoff, mipslelf, mipsbelf. The first two do not alter the default endianness from that of the primary target for which the assembler was configured; the others change the default to little- or big-endian as indicated by the b or l in the name. Using -EB or -EL will override the endianness selection in any case.
> > This option is currently supported only when the primary target for which as is configured is a MIPS ELF or ECOFF target. Furthermore, the primary target or others specified with --enable-targets=name (where name is the target) at configuration time must include support for the other format, if both are to be available. For example, the Irix 5 configuration includes support for both. Eventually, this option will support more configurations, with more fine-grained control over the assembler’s behavior, and will be supported for more processors.

> -nocpp

> > Ignored. It is accepted for compatibility with the native tools.

> --trap
> --no-trap
> --break
> --no-break

> > Control how to deal with multiplication overflow and division by zero. --trap or --no-break (which are synonyms) take a trap exception (and only work for Instruction Set Architecture level 2 and higher); --break or --no-trap (also synonyms, and the default) take a break exception.

Top|Contents|Index|Next